WindowAdapter (Java SE 26 & JDK 26)
Description: declaration: module: java.desktop, package: java.awt.event, class: WindowAdapter
Keywords: java.awt.event.WindowAdapter class

# Class WindowAdapter

java.lang.Object
java.awt.event.WindowAdapter

All Implemented Interfaces:
  `WindowFocusListener, WindowListener, WindowStateListener, EventListener`

Direct Known Subclasses:
  `BasicToolBarUI.FrameListener, JMenu.WinListener`

public abstract class WindowAdapter extends Object implements WindowListener, WindowStateListener, WindowFocusListener
An abstract adapter class for receiving window events. The methods in this class are empty. This class exists as convenience for creating listener objects.

Extend this class to create a `WindowEvent` listener and override the methods for the events of interest. (If you implement the `WindowListener` interface, you have to define all of the methods in it. This abstract class defines null methods for them all, so you can only have to define methods for events you care about.)

Create a listener object using the extended class and then register it with a Window using the window's `addWindowListener` method. When the window's status changes by virtue of being opened, closed, activated or deactivated, iconified or deiconified, the relevant method in the listener object is invoked, and the `WindowEvent` is passed to it.

Since:
  1.1
See Also:
  - `WindowEvent`
  - `WindowListener`
  - Tutorial: Writing a Window Listener

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `WindowAdapter()`
  Constructs a `WindowAdapter`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `windowActivated(WindowEvent e)`
  Invoked when a window is activated.
  `void`
  `windowClosed(WindowEvent e)`
  Invoked when a window has been closed.
  `void`
  `windowClosing(WindowEvent e)`
  Invoked when a window is in the process of being closed.
  `void`
  `windowDeactivated(WindowEvent e)`
  Invoked when a window is de-activated.
  `void`
  `windowDeiconified(WindowEvent e)`
  Invoked when a window is de-iconified.
  `void`
  `windowGainedFocus(WindowEvent e)`
  Invoked when the Window is set to be the focused Window, which means that the Window, or one of its subcomponents, will receive keyboard events.
  `void`
  `windowIconified(WindowEvent e)`
  Invoked when a window is iconified.
  `void`
  `windowLostFocus(WindowEvent e)`
  Invoked when the Window is no longer the focused Window, which means that keyboard events will no longer be delivered to the Window or any of its subcomponents.
  `void`
  `windowOpened(WindowEvent e)`
  Invoked when a window has been opened.
  `void`
  `windowStateChanged(WindowEvent e)`
  Invoked when a window state is changed.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### WindowAdapter

    protected WindowAdapter()
    Constructs a `WindowAdapter`.

- ## Method Details

  - ### windowOpened

    public void windowOpened(WindowEvent e)
    Invoked when a window has been opened.
    Specified by:
      `windowOpened` in interface `WindowListener`
    Parameters:
      `e` - the event to be processed

  - ### windowClosing

    public void windowClosing(WindowEvent e)
    Invoked when a window is in the process of being closed. The close operation can be overridden at this point.
    Specified by:
      `windowClosing` in interface `WindowListener`
    Parameters:
      `e` - the event to be processed

  - ### windowClosed

    public void windowClosed(WindowEvent e)
    Invoked when a window has been closed.
    Specified by:
      `windowClosed` in interface `WindowListener`
    Parameters:
      `e` - the event to be processed

  - ### windowIconified

    public void windowIconified(WindowEvent e)
    Invoked when a window is iconified.
    Specified by:
      `windowIconified` in interface `WindowListener`
    Parameters:
      `e` - the event to be processed
    See Also:
      - `Window.setIconImage(Image)`

  - ### windowDeiconified

    public void windowDeiconified(WindowEvent e)
    Invoked when a window is de-iconified.
    Specified by:
      `windowDeiconified` in interface `WindowListener`
    Parameters:
      `e` - the event to be processed

  - ### windowActivated

    public void windowActivated(WindowEvent e)
    Invoked when a window is activated.
    Specified by:
      `windowActivated` in interface `WindowListener`
    Parameters:
      `e` - the event to be processed

  - ### windowDeactivated

    public void windowDeactivated(WindowEvent e)
    Invoked when a window is de-activated.
    Specified by:
      `windowDeactivated` in interface `WindowListener`
    Parameters:
      `e` - the event to be processed

  - ### windowStateChanged

    public void windowStateChanged(WindowEvent e)
    Invoked when a window state is changed.
    Specified by:
      `windowStateChanged` in interface `WindowStateListener`
    Parameters:
      `e` - the event to be processed
    Since:
      1.4

  - ### windowGainedFocus

    public void windowGainedFocus(WindowEvent e)
    Invoked when the Window is set to be the focused Window, which means that the Window, or one of its subcomponents, will receive keyboard events.
    Specified by:
      `windowGainedFocus` in interface `WindowFocusListener`
    Parameters:
      `e` - the event to be processed
    Since:
      1.4

  - ### windowLostFocus

    public void windowLostFocus(WindowEvent e)
    Invoked when the Window is no longer the focused Window, which means that keyboard events will no longer be delivered to the Window or any of its subcomponents.
    Specified by:
      `windowLostFocus` in interface `WindowFocusListener`
    Parameters:
      `e` - the event to be processed
    Since:
      1.4